package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.UserPointsLogService;
import com.gxwebsoft.shop.entity.UserPointsLog;
import com.gxwebsoft.shop.param.UserPointsLogParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户积分变动明细表控制器
 *
 * @author 科技小王子
 * @since 2022-11-25 19:04:43
 */
@Api(tags = "用户积分变动明细表管理")
@RestController
@RequestMapping("/api/shop/user-points-log")
public class UserPointsLogController extends BaseController {
    @Resource
    private UserPointsLogService userPointsLogService;

    @PreAuthorize("hasAuthority('shop:userPointsLog:list')")
    @OperationLog
    @ApiOperation("分页查询用户积分变动明细表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserPointsLog>> page(UserPointsLogParam param) {
        PageParam<UserPointsLog, UserPointsLogParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userPointsLogService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(userPointsLogService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:list')")
    @OperationLog
    @ApiOperation("查询全部用户积分变动明细表")
    @GetMapping()
    public ApiResult<List<UserPointsLog>> list(UserPointsLogParam param) {
        PageParam<UserPointsLog, UserPointsLogParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userPointsLogService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(userPointsLogService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:list')")
    @OperationLog
    @ApiOperation("根据id查询用户积分变动明细表")
    @GetMapping("/{id}")
    public ApiResult<UserPointsLog> get(@PathVariable("id") Integer id) {
        return success(userPointsLogService.getById(id));
        // 使用关联查询
        //return success(userPointsLogService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:save')")
    @OperationLog
    @ApiOperation("添加用户积分变动明细表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserPointsLog userPointsLog) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          userPointsLog.setUserId(loginUser.getUserId());
        }
        if (userPointsLogService.save(userPointsLog)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:update')")
    @OperationLog
    @ApiOperation("修改用户积分变动明细表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserPointsLog userPointsLog) {
        if (userPointsLogService.updateById(userPointsLog)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:remove')")
    @OperationLog
    @ApiOperation("删除用户积分变动明细表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userPointsLogService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:save')")
    @OperationLog
    @ApiOperation("批量添加用户积分变动明细表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserPointsLog> list) {
        if (userPointsLogService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:update')")
    @OperationLog
    @ApiOperation("批量修改用户积分变动明细表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserPointsLog> batchParam) {
        if (batchParam.update(userPointsLogService, "log_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userPointsLog:remove')")
    @OperationLog
    @ApiOperation("批量删除用户积分变动明细表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userPointsLogService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
